MeatAxe: Integer Matrices

MeatAxe 2.4

- Main Page
- Related Pages
- Modules
- Data Structures

Data Structures | Functions
Integer Matrices

## Data Structures
class | IntMatrix_t
| An Integer Matrix. More...
## Functions
int | ImatIsValid (const IntMatrix_t *mat)
| Check an Integer Matrix.
IntMatrix_t * | ImatAlloc (int nor, int noc)
| Create a New Integer Matrix.
int | ImatFree (IntMatrix_t *mat)
| Delete an Integer Matrix.
IntMatrix_t * | ImatRead (FILE *f)
| Read an integer matrix from a file.
IntMatrix_t * | ImatLoad (const char *fn)
| Read an Integer Matrix From a File.
int | ImatWrite (const IntMatrix_t *mat, FILE *f)
| Write an integer matrix to a file.
int | ImatSave (const IntMatrix_t *mat, const char *file_name)
| Write an Integer Matrix to a File.

## Function Documentation

IntMatrix_t* ImatAlloc | ( | int | nor,
|  | int | noc
| ) |  |

Create a New Integer Matrix.

This function creates a new integer matrix with |nor| rows and |noc| columns. To destroy an integer matrix, use ImatFree(), not SysFree().

Parameters:

  nor | Number of rows.
  noc | Number of columns.

Returns:
  Pointer to the new matrix or 0 on error.

int ImatFree | ( | IntMatrix_t * | mat | ) |

Delete an Integer Matrix.

This function frees a matrix which has beed created by ImatAlloc(). This implies freeing the internal data buffers as well as the IntMatrix_t structure itself.

Parameters:

  mat | Pointer to the matrix.

Returns:
  0 on success, -1 on error.

int ImatIsValid | ( | const IntMatrix_t * | mat | ) |

Check an Integer Matrix.

This function checks if the argument is a pointer to a valid integer matrix. If the matrix is o.k., the function returns 1. Otherwise, an error is signalled and, if the error handler does not terminate the program, the function returns 0.

Parameters:

  mat | Pointer to the matrix.

Returns:
  1 if mat points to a valid matrix, 0 otherwise.

IntMatrix_t* ImatLoad | ( | const char * | fn | ) |

Read an Integer Matrix From a File.

This function opens a file, reads a single integer matrix, and closes the file. To read more than one matrix from a file, use ImatRead().

Parameters:

  fn | File name.

Returns:
  Pointer to the matrix, or 0 on error.

IntMatrix_t* ImatRead | ( | FILE * | f | ) |

Read an integer matrix from a file.

This function reads an integer matrix from a file.

See also:
  ImatLoad()

Parameters:

  f | File to read from.

Returns:
  Pointer to the matrix, or 0 on error.

int ImatSave | ( | const IntMatrix_t * | mat,
|  | const char * | file_name
| ) |  |

Write an Integer Matrix to a File.

This function writes an integer matrix to a named file. If the file exists, it is destroyed.

See also:
  ImatWrite()

Parameters:

  mat | Pointer to the matrix.
  file_name | File name.

Returns:
  0 on success, -1 on error.

int ImatWrite | ( | const IntMatrix_t * | mat,
|  | FILE * | f
| ) |  |

Write an integer matrix to a file.

See also:
  ImatSave

Parameters:

  mat | Pointer to the matrix.
  f | Pointer to the file.

Returns:
  0 on success, -1 on error.